unit veditorsimple;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, ComCtrls,uvacercade,bommemo
  {$IFDEF Windows}
   ,Windows
  {$ENDIF};

type

  { TVentanaEditor }

  TVentanaEditor = class(TForm)
    Editor: TBOMMemo;
    Imagenes: TImageList;
    MenuArchivo: TMenuItem;
    MenuEdicion: TMenuItem;
    MenuAcercaDe: TMenuItem;
    MenuAbrir: TMenuItem;
    MenuGuardar: TMenuItem;
    MenuCopiar: TMenuItem;
    MenuBOM: TMenuItem;
    MenuGuardarComo: TMenuItem;
    MenuNuevo: TMenuItem;
    MenuPegar: TMenuItem;
    MenuSalir: TMenuItem;
    MenuPrincipal: TMainMenu;
    BarraHerramientas: TToolBar;
    BNuevo: TToolButton;
    BAbrir: TToolButton;
    BGuardar: TToolButton;
    BarraEstado: TStatusBar;
    ToolButton1: TToolButton;
    BCopiar: TToolButton;
    BPegar: TToolButton;
    ToolButton2: TToolButton;
    BBOM: TToolButton;
    ToolButton3: TToolButton;
    BTitulos: TToolButton;
    VentanaGuardar: TSaveDialog;
    VentanaAbrir: TOpenDialog;
    procedure BTitulosClick(Sender: TObject);
    procedure FormClose(Sender: TObject);// var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MenuAbrirClick(Sender: TObject);
    procedure MenuAcercaDeClick(Sender: TObject);
    procedure MenuBOMClick(Sender: TObject);
    procedure MenuCopiarClick(Sender: TObject);
    procedure MenuGuardarClick(Sender: TObject);
    procedure MenuGuardarComoClick(Sender: TObject);
    procedure MenuNuevoClick(Sender: TObject);
    procedure MenuPegarClick(Sender: TObject);
    procedure MenuSalirClick(Sender: TObject);
    procedure CambiarEstadoBOM(estado:boolean);
    procedure CambiarEstadoGuardar(estado:boolean);
    procedure EditorChange(Sender:TObject);
    {$IFDEF Windows}
    procedure GuardarUTF16(Arch:unicodestring);
    procedure AbrirUTF16(Arch:unicodestring);
    {$ENDIF}
  private
    { private declarations }
  public
    { public declarations }
    modificado:boolean;
    NombreArch:unicodestring;
  end; 

var
  VentanaEditor: TVentanaEditor;

implementation

{$R *.lfm}

{ TVentanaEditor }

procedure TVentanaEditor.MenuSalirClick(Sender: TObject);
begin
  Close
end;

procedure TVentanaEditor.CambiarEstadoBOM(estado: boolean);
begin
  if estado then
    Begin
      BBOM.ImageIndex:=6;
      BBOM.Down:=true;
      MenuBOM.Checked:=true;
    end
  else
    Begin
      BBOM.ImageIndex:=5;
      BBOM.Down:=false;
      MenuBOM.Checked:=false;
    end;
end;

procedure TVentanaEditor.CambiarEstadoGuardar(estado: boolean);
begin
  BGuardar.Enabled:=estado;
  MenuGuardar.Enabled:=estado;
end;

procedure TVentanaEditor.EditorChange(Sender: TObject);
begin
  modificado:=true;
  MenuGuardarComo.Enabled:=true;
  CambiarEstadoGuardar(true)
end;
{$IFDEF Windows}
procedure TVentanaEditor.GuardarUTF16(Arch: unicodestring);
var arch1:THandle;
    arch2:THandleStream;
begin
  arch1:=CreateFileW(PWideChar(Arch),GENERIC_READ or GENERIC_WRITE,0,nil,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
  arch2:=THandleStream.create(arch1);
  Editor.Lines.SaveToStream(arch2);
  FileClose(Arch1)
end;

procedure TVentanaEditor.AbrirUTF16(Arch: unicodestring);
var arch1:THandle;
    arch2:THandleStream;
begin
  arch1:=CreateFileW(PWideChar(Arch),GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  arch2:=THandleStream.create(arch1);
  Editor.Lines.LoadFromStream(arch2);
  FileClose(Arch1)
end;
{$ENDIF}

procedure TVentanaEditor.MenuCopiarClick(Sender: TObject);
begin
  Editor.CopyToClipboard;
end;

procedure TVentanaEditor.MenuGuardarClick(Sender: TObject);
begin
  if NombreArch='' then
  Begin
    if VentanaGuardar.Execute then
     Begin
      {$IFDEF Linux}Editor.Lines.SaveToFile(VentanaGuardar.FileName);{$ENDIF}
      {$IFDEF Windows}GuardarUTF16(UTF8Decode(VentanaGuardar.FileName));{$ENDIF}
      modificado:=false;
      NombreArch:=VentanaGuardar.FileName;
      CambiarEstadoGuardar(false)
    end;
  end
  else
    Begin
      {$IFDEF Linux}Editor.Lines.SaveToFile(NombreArch);{$ENDIF}
      {$IFDEF Windows}GuardarUTF16(UTF8Decode(NombreArch));{$ENDIF}
      modificado:=false;
      CambiarEstadoGuardar(false)
    end;
  BarraEstado.Panels.Items[0].Text:=NombreArch
end;

procedure TVentanaEditor.MenuGuardarComoClick(Sender: TObject);
begin
  if VentanaGuardar.Execute then
   Begin
   {$IFDEF Linux}Editor.Lines.SaveToFile(VentanaGuardar.FileName);{$ENDIF}
   {$IFDEF Windows}GuardarUTF16(UTF8Decode(VentanaGuardar.FileName));{$ENDIF}
    modificado:=false;
    NombreArch:=VentanaGuardar.FileName;
    CambiarEstadoGuardar(false);
    BarraEstado.Panels.Items[0].Text:=NombreArch
   end;
end;

procedure TVentanaEditor.MenuNuevoClick(Sender: TObject);
begin
  FormClose(Sender);
  if Editor.Lines.Text<>'' then
    Editor.Lines.Text:='';
  CambiarEstadoBOM(false);
  modificado:=false;
  NombreArch:='';
  MenuGuardarComo.Enabled:=false;
  CambiarEstadoGuardar(false);
  BarraEstado.Panels.Items[0].Text:=''
end;

procedure TVentanaEditor.MenuAbrirClick(Sender: TObject);
begin
  FormClose(Sender);
  if VentanaAbrir.Execute then
    Begin
     {$IFDEF Linux}Editor.Lines.LoadFromFile(VentanaAbrir.FileName);{$ENDIF}
     {$IFDEF Windows}AbrirUTF16(UTF8Decode(VentanaAbrir.FileName));{$ENDIF}
     CambiarEstadoBOM(Editor.BOM);
     NombreArch:=VentanaAbrir.FileName
    end;
  modificado:=false;
  MenuGuardarComo.Enabled:=true;
  CambiarEstadoGuardar(false);
  BarraEstado.Panels.Items[0].Text:=NombreArch
end;

procedure TVentanaEditor.BTitulosClick(Sender: TObject);
begin
  if BarraHerramientas.ShowCaptions then
    Begin
      BarraHerramientas.ShowCaptions:=false;
      BarraHerramientas.ShowHint:=true;
      BarraHerramientas.ButtonHeight:=40;
      BarraHerramientas.ButtonWidth:=40;
      BarraHerramientas.Height:=43;
      BTitulos.ImageIndex:=8;
    end
  else
    Begin
      BarraHerramientas.ShowCaptions:=true;
      BarraHerramientas.ShowHint:=false;
      BarraHerramientas.ButtonHeight:=60;
      BarraHerramientas.ButtonWidth:=60;
      BarraHerramientas.Height:=63;
      BTitulos.ImageIndex:=7;
    end;
end;

procedure TVentanaEditor.FormClose(Sender: TObject);
  //var CloseAction: TCloseAction);
begin
  if modificado then
    if mrYes=MessageDlg('Editor Simple','El documento actual no se ha guardado'+#13+'¿Desea guardarlo?',mtConfirmation,[mbYes,mbNo],0)
       then MenuGuardarClick(Sender)
end;

procedure TVentanaEditor.FormShow(Sender: TObject);
begin
  Editor:=TBOMMemo.create(self);
  Editor.Parent:=self;
  Editor.Align:=alClient;
  Editor.ScrollBars:=ssAutoBoth;
  modificado:=false;
  Editor.OnChange:=@EditorChange;
  NombreArch:='';
  MenuGuardarComo.Enabled:=false;
  CambiarEstadoGuardar(false);
  BarraEstado.Panels.Items[0].Text:=''
end;

procedure TVentanaEditor.MenuAcercaDeClick(Sender: TObject);
begin
  VAcercade.ShowModal;
end;

procedure TVentanaEditor.MenuBOMClick(Sender: TObject);
var aux:boolean;
begin
  if Editor.BOM then
    Begin
      Editor.QuitarBOM;
      if Editor.Lines.text='' then modificado:=false;
    end
  else
    Begin
      aux:=true;
      if Editor.Lines.text='' then aux:=false;
      Editor.PonerBOM;
      modificado:=aux
    end;
  CambiarEstadoBOM(Editor.BOM);
  if not modificado then CambiarEstadoGuardar(false)
end;

procedure TVentanaEditor.MenuPegarClick(Sender: TObject);
begin
  Editor.PasteFromClipboard;
end;

end.

